#ifndef _CONFIG_H_
#define _CONFIG_H_


void load_config();

struct Config
{
	bool use_planning;
	
	// Debug
	bool record_maps;
	
	// Global
	int control_period; // ms
	int planning_period; // ms

	char *global_map_file;
	float start_x; // cm
	float start_y; // cm
	float start_theta; // deg
	float goal_x; // cm
	float goal_y; // cm

	float max_speed; // cm/s
	float max_rot_speed; // /s
	float max_decel;
	
	// VFH tuning
	int active_window_size; // 13
	int smooth_polar_width; // 5
	int wide_valley_size; // 18
	int polar_sectors; // 72
	int max_probes; // 50
	int local_map_size; // 21
	int dilatation_size; // 1
	float histo_thres; // 20
	float speed_reduction; // 100 , hm coeff
	float min_speed;
	float cell_size; // cm
	// VFH features
	bool global_memory; /// does the robot recall what it detected before outside its current local map (ie there is not really local map)
	bool vote_noobst; /// vote for non obstacle positions

};

extern Config config;


#endif


