#ifndef _IO_H_
#define _IO_H_

#include "datastruct.h"
/*
class Sensor
{
 public:
	int id;
	float x, y; /// positiion  / center of robot
	float theta; /// direction of sensor
	
	Sensor(int id, float x, float y, float theta): id(id), x(x), y(y), theta(theta) {}
	Sensor() {}
	float read(); /// meters
	
};
*/

struct SensorReading
{
	float x, y, theta; /// the robot when the measure was taken
	float x_, y_, theta_; /// original values
	float angle;
	float value;
	float value_;
	bool updated;
	bool initialized;
	bool is_working;
};


class Robot
{
 public:
	float w, h; /// width and heights
	int nsensors;
	SensorReading *readings;
//	Sensor *sensors;
	float minSensorRange; /// (cm) if no obstacle, consider we are sure there is no obstacle up to this distance
	float maxSensorRange; /// (cm) if value greater, consider there is no obstacle

	
	
	float sonar_outrange;
	RobotState state;
	RobotState initState;
	
	Robot(float w, float h, int nsensors): w(w), h(h), nsensors(nsensors)
		{ readings = new SensorReading[nsensors]; for(int i = 0; i < nsensors; i++) readings[i].updated = false;  }
	void init(char *hserver_name);
	void close();
	void refreshState();
	void setDirSpeed(float theta, float speed); ///
	void stop(); ///
	void updateReadings();
	
};



#endif
